<template>
	<f7-page 
        name="announcement" 
        @page:beforein="onPageBeforeIn" 
        @page:beforeout="onPageBeforeOut" 
        ptr 
        @ptr:refresh="onPageRefresh"
        infinite
        :infinite-distance="50"
        :infinite-preloader="showPreloader"
        @infinite="loadMore">

		<!-- Top Navbar -->

		<f7-navbar :sliding="false" large title-large="Berita">
			<f7-nav-left back-link></f7-nav-left>
            <f7-nav-title class="show-small-title">{{ currentCategory }}</f7-nav-title>
		</f7-navbar>

		<!-- Page content-->
        <f7-block v-if="announcementCategories.length > 0">
			<f7-toolbar tabbar scrollable position="top" no-shadow no-hairlines class="no-background" style="top:0;">
                <f7-link @click="handleAnnouncementCategory('semua')" :class="`gradient-box${slugify(currentCategory) == 'semua' ? ' tab-link-active' : ''}`">
					<span class="">Semua</span>									
				</f7-link>
				<f7-link @click="handleAnnouncementCategory(item.slug)" :class="`gradient-box${slugify(currentCategory) == item.slug ? ' tab-link-active' : ''}`" v-for="(item, index) in announcementCategories" :key="index">
					<span class="">{{ item.name }}</span>									
				</f7-link>
			</f7-toolbar>
		</f7-block>
        <f7-list media-list no-hairlines v-if="!announcementLoading && announcements.length > 0">
            <f7-list-item
                v-for="(item, index) in announcements"
                :key="index"
                :link="`/announcements/view/${item.id}/`"
                :after="hoursAgo(item.created)"
                :title="item.category.name"
                :subtitle="item.title"
                :text="truncate(stripHTML(item.body))"
            >
                <img v-if="item.author.profile.media != null" :src="item.author.profile.media.url.small" width="48" height="48" class="img-circle" slot="media"/>
                <div v-else :data-initial-medium="item.author.profile.initial" slot="media"></div>
            </f7-list-item>
            
        </f7-list>
        <f7-block v-else-if="!announcementLoading" style="height: calc(100% - 100px)">
			<span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 100px);">
				<span class="text-align-center">
					<span class="display-block text-align-center">
						<f7-icon material="notifications_off" style="font-size:100px;color:#eee;"></f7-icon>
						<span class="display-block">It's a little quiet here</span>
					</span>
				</span>
			</span>
		</f7-block>
        <f7-list media-list no-hairlines v-if="announcementLoading">
            <f7-list-item
                v-for="n in 4"
                :key="n"
                class="skeleton-text skeleton-effect-blink"
                title="Full Name"
                subtitle="Position"
                after="31 Juli 2019"
                text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi lobortis et massa ac interdum. Cras consequat felis at consequat hendrerit. Aliquam vestibulum vitae lorem ac iaculis. Praesent nec pharetra massa, at blandit lectus. Sed tincidunt, lectus eu convallis elementum, nibh nisi aliquet urna, nec imperdiet felis sapien at enim."
            >
                <f7-skeleton-block style="width: 48px; height: 48px; border-radius: 50%" slot="media"></f7-skeleton-block>
            </f7-list-item>
        </f7-list>
    </f7-page>
</template>
<script>
import { mapGetters } from 'vuex';
import { hoursAgo, dateFormat, truncate, stripHTML, slugify } from '../js/utils';
import { setTimeout } from 'timers';
export default {
    name: 'Announcement',
    data(){
        return {
            announcementLoading: true,
            allowInfinite: true,
            showPreloader: true,
            currentCategory: 'Semua',
            currentCategoryId: null,
        };
    },
    computed: {
        ...mapGetters('auth', ['user']),
        ...mapGetters('category', [
            'announcementCategories'
        ]),
		...mapGetters('announcement', [
			'announcements',
			'pagination'
		])
    },
    mounted: function() {
        const self = this; 
        const $$ = self.$$;
        const $el = $$(self.$el);
    },
    methods: {
        hoursAgo,
        dateFormat,
        truncate,
        stripHTML,
        slugify,
        getCategories(){
			const self = this;
			const app = self.$f7;

			this.$store.dispatch('category/getCategories', {
				module: 'announcement',
				page: 1,
                perpage: 100,
                only: 'id,name,slug'
			});
		},
        getAnnouncements(page, loadmore){
			const self = this;
            const app = self.$f7;
            
			self.$store.dispatch('announcement/getAnnouncements', {
				status: 'publish',
				page: page,
                perpage: 25,
                loadmore: loadmore,
                category: self.currentCategoryId,
                only: 'id,number,title,body,created,updated,category.id,category.name,medias.mimetype,medias.url,medias.filename,medias.original_filename,signs,residentials.name,residentials.address,residentials.administrative_region,author.id,author.profile.fullname,author.profile.initial,author.profile.media'
			}).then(() => {
                setTimeout(() => {
                    self.showPreloader = self.pagination.has_next;
                    self.announcementLoading = false;
                }, 100)
            });
		},
        onPageBeforeIn(){
            const self = this;

            self.getCategories();
            self.getAnnouncements(1, false);
        },
        onPageBeforeIn(){
            const self = this;

            self.getCategories();
            self.getAnnouncements(1, false);
        },
        onPageBeforeOut(page){
            const self = this;

            if(page.detail.name == 'announcement'){
                self.currentCategory = 'Semua';
                self.currentCategoryId = null;
                self.$store.dispatch('category/resetCategories', {
                    module: 'announcement'
                });
                self.$store.dispatch('announcement/resetAnnouncements');
            }
        },
        onPageRefresh(e, done){
            const self = this;

            self.$store.dispatch('category/resetCategories', {
                module: 'announcement'
            }).then(()=>{
                self.financialReportLoading = false;
                self.getCategories();
            });

            self.getAnnouncements(1, false);
            done();
        },
        loadMore() {
            const self = this;

            if (!self.allowInfinite) return;
            self.allowInfinite = false;

            setTimeout(()=>{
                if(self.pagination.has_next){
                    self.getAnnouncements(self.pagination.page + 1, true);
                    self.allowInfinite = true;                 
                }else{
                    self.showPreloader = false;
                }
            }, 1000);
        },
        handleAnnouncementCategory(category){
			const self = this;
            const app = self.$f7;
            
            self.announcementLoading = true;
            
            if(category != 'semua'){                
                for(const x of self.announcementCategories){
                    if(x.slug == category){
                        self.currentCategory = x.name;
                        self.currentCategoryId = x.id;
                        break;
                    }
                }
            }else{
                self.currentCategoryId = null;
                self.currentCategory = 'Semua';
            }

            self.$store.dispatch('announcement/resetAnnouncements').then(()=>{
                self.getAnnouncements(1, false);
            });
		}
    }
}
</script>
